Subject: Re: e1000 driver 2.6.18 - how to waste processor cycles

From: "Jeff V. Merkey" <[email-masked]>
Date: Thu, 09 Nov 2006 15:49:30 -0700

Jesse Brandeburg wrote:

> On 11/9/06, Jeffrey V. Merkey <[email-masked]> wrote:
>
>> In the case I am referring to, the memory is already mapped with a
>> previous call, which means it may be getting
>> mapped twice.
>
>
> I guess maybe I'm not keeping up with you.  This is what I see looking
> in 2.6.18, i see e1000_clean_rx_irq:

Check e1000_alloc_rx_buffers:

if (skb already exists in ring buffer)
  goto map_skb:
else
   dev_alloc_skb
  ( drop through to map_skb)

map_skb:
  pci_map_single

Jeff

>
> check done bit
> pci_unmap_single
> copybreak and recycle
> OR
> hand buffer up stack
>
> the only branch before the unmap is the napi break out, and in that
> case we don't change any memory state, so alloc will not do anything.
>
> As for alloc rx, we always map, because we always unmapped.
>
> Did I miss something?  I would appreciate a more detailed explanation
> of what you see going wrong.
>
>